# Contributor License Agreements

We'd love to accept your code patches! However, before we can take them, we have to clear a couple of legal hurdles.

- Please fill out either the individual or corporate Contributor License Agreement.
  - If you are an individual writing original source code and are sure you own the intellectual property, then you'll need to sign an individual CLA available at:

      https://developers.google.com/open-source/cla/individual.

  - If you work for a company that wants to allow you to contribute your work to this client library, then you'll need to sign a corporate CLA available at:

      https://developers.google.com/open-source/cla/corporate.

Follow either of the two links above to access the appropriate CLA and instructions on how to sign and return it. Once we receive the CLA, we'll add you to the official list of contributors and will be able to accept your patches.

# Submitting Patches

- Sign a Contributor License Agreement (see above).
- Join the appropriate product discussion forum.
  - AdWords API: https://developers.google.com/adwords/api/community/
  - DFP API: https://developers.google.com/doubleclick-publishers/community
  - DFA API: https://developers.google.com/doubleclick-advertisers/reporting/community
- Create an issue on the library issue tracker if there isn't one already. Use this issue to co-ordinate the changes with the library maintainer.
- Fork the library, make the changes and send a [pull request](https://help.github.com/articles/using-pull-requests).
- The library maintainer will work with you to review and apply the patch.

# If you can't become a contributor

If you can't become a contributor, but wish to share some code that illustrates an issue / shows how an issue may be fixed, then you can attach your changes on the issue tracker. We will use this code to troubleshoot the issue and fix it, but will not use this code in the library unless the steps to submit patches are done.
